=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2006-12-18 20:52:28 +0000
+++ loggerhead/TODO	2006-12-18 22:07:40 +0000
@@ -22,5 +22,3 @@
 
 * make equivalent of start page:
     http://goffredo-baroncelli.homelinux.net/bazaar
-
-* add download link to revision, inventory pages too

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2006-12-18 20:52:28 +0000
+++ loggerhead/controllers/inventory_ui.py	2006-12-18 22:07:40 +0000
@@ -52,6 +52,7 @@
             revid = None
         
         file_id = kw.get('file_id', None)
+        sort_type = kw.get('sort', None)
 
         try:
             revlist, revid = h.get_navigation(revid, file_id)
@@ -90,7 +91,7 @@
             'path': path,
             'updir': updir,
             'updir_file_id': updir_file_id,
-            'filelist': h.get_filelist(inv, path),
+            'filelist': h.get_filelist(inv, path, sort_type),
             'history': h,
             'posixpath': posixpath,
             'navigation': navigation,

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-18 20:52:28 +0000
+++ loggerhead/history.py	2006-12-18 22:07:40 +0000
@@ -640,7 +640,7 @@
         return util.Container(added=added, renamed=renamed, removed=removed, modified=modified)
 
     @with_branch_lock
-    def get_filelist(self, inv, path):
+    def get_filelist(self, inv, path, sort_type=None):
         """
         return the list of all files (and their attributes) within a given
         path subtree.
@@ -649,7 +649,6 @@
             path = path[:-1]
         if path.startswith('/'):
             path = path[1:]
-        parity = 0
         
         entries = inv.entries()
         
@@ -657,7 +656,8 @@
         for filepath, entry in entries:
             fetch_set.add(entry.revision)
         change_dict = dict([(c.revid, c) for c in self.get_changes(list(fetch_set))])
-            
+        
+        file_list = []
         for filepath, entry in entries:
             if posixpath.dirname(filepath) != path:
                 continue
@@ -671,10 +671,23 @@
             revid = entry.revision
             change = change_dict[revid]
             
-            yield util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
-                                 pathname=pathname, file_id=entry.file_id, revid=revid, change=change, parity=parity)
+            file = util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
+                                  pathname=pathname, file_id=entry.file_id, size=entry.text_size, revid=revid, change=change)
+            file_list.append(file)
+        
+        if sort_type == 'filename':
+            file_list.sort(key=lambda x: x.filename)
+        elif sort_type == 'size':
+            file_list.sort(key=lambda x: x.size)
+        elif sort_type == 'date':
+            file_list.sort(key=lambda x: x.change.date)
+        
+        parity = 0
+        for file in file_list:
+            file.parity = parity
             parity ^= 1
-        pass
+
+        return file_list
 
 
     _BADCHARS_RE = re.compile(ur'[\x00-\x1f]')

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2006-12-18 20:52:28 +0000
+++ loggerhead/static/css/style.css	2006-12-18 22:07:40 +0000
@@ -175,7 +175,7 @@
 
 .info-entry td {
     font-weight: normal;
-      padding-left: 0.5em;
+    padding-left: 0.5em;
     padding-top: 2px;
     padding-bottom: 2px;
 }
@@ -304,7 +304,7 @@
 
 .revision-info td {
     font-weight: normal;
-      padding-left: 0.5em;
+    padding-left: 0.5em;
     padding-top: 2px;
     padding-bottom: 2px;
 }
@@ -452,7 +452,7 @@
 
 .inventory td.permissions {
     font-family: monospace;
-    width: 10em;
+    width: 9em;
     padding-left: 0.5em;
 }
 
@@ -460,6 +460,12 @@
     font-family: monospace;
 }
 
+.inventory td.size {
+	font-family: monospace;
+	font-size: smaller;
+	width: 5em;
+}
+
 .inventory td.revision {
     width: 8em;
     padding-right: 1.5em;
@@ -477,6 +483,11 @@
     font-size: smaller;
 }
 
+.inventory td.download-link {
+    width: 8em;
+    font-size: smaller;
+}
+
 span.folder {
     font-family: monospace;
 }

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2006-12-18 20:52:28 +0000
+++ loggerhead/templates/inventory.kid	2006-12-18 22:07:40 +0000
@@ -60,16 +60,18 @@
 <table class="inventory" width="100%">
     <tr class="header">
         <th class="permissions"> Permissions </th>
-        <th> Filename </th>
+        <th> <a href="${tg.url([ '/files', revid ], file_id=file_id, sort='filename')}">Filename</a> </th>
+        <th> <a href="${tg.url([ '/files', revid ], file_id=file_id, sort='size')}">Size</a> </th>
         <th> Last change </th>
-        <th> When </th>
+        <th> <a href="${tg.url([ '/files', revid ], file_id=file_id, sort='date')}">When</a> </th>
         <th> History </th>
+        <th> Download </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
         <td class="permissions">drwxr-xr-x</td>
         <td class="filename directory"><a href="${tg.url([ '/files', revid ], file_id=updir_file_id)}"> (up) </a></td>
-        <td> </td> <td> </td> <td> </td>
+        <td> </td> <td> </td> <td> </td> <td> </td>
     </tr>
 
     <tr py:for="file in filelist" class="parity${file.parity}">
@@ -79,9 +81,11 @@
             <span py:if="file.kind=='symlink'">${file.filename}@</span>
             <a py:if="file.kind=='file'" href="${tg.url([ '/annotate', revid ], file_id=file.file_id)}">${file.filename}</a>
         </td>
+        <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
         <td class="revision"> ${revlink(file.revid, file.revid, file.file_id, util.trunc(file.change.revno, 15))} </td>
         <td class="date"> ${file.change.date.strftime('%d %b %Y %H:%M')} </td>
         <td class="changes-link"> <a href="${tg.url('/changes', start_revid=file.revid, file_id=file.file_id)}"> &#8594; changes </a></td>
+        <td class="download-link"> <a href="${tg.url([ '/download', file.revid, file.file_id, file.filename ])}"> &#8594; download </a></td>
     </tr>
 </table>
 

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2006-12-18 20:52:28 +0000
+++ loggerhead/util.py	2006-12-18 22:07:40 +0000
@@ -192,6 +192,46 @@
     return format % value
 
 
+KILO = 1024
+MEG = 1024 * KILO
+GIG = 1024 * MEG
+P95_MEG = int(0.9 * MEG)
+P95_GIG = int(0.9 * GIG)
+
+def human_size(size, min_divisor=0):
+    size = int(size)
+    if (size == 0) and (min_divisor == 0):
+        return '0'
+    if (size < 512) and (min_divisor == 0):
+        return str(size)
+
+    if (size >= P95_GIG) or (min_divisor >= GIG):
+        divisor = GIG
+    elif (size >= P95_MEG) or (min_divisor >= MEG):
+        divisor = MEG
+    else:
+        divisor = KILO
+    
+    dot = size % divisor
+    base = size - dot
+    dot = dot * 10 // divisor
+    base //= divisor
+    if dot >= 10:
+        base += 1
+        dot -= 10
+    
+    out = str(base)
+    if (base < 100) and (dot != 0):
+        out += '.%d' % (dot,)
+    if divisor == KILO:
+        out += 'K'
+    elif divisor == MEG:
+        out += 'M'
+    elif divisor == GIG:
+        out += 'G'
+    return out
+    
+
 def fill_in_navigation(history, navigation):
     """
     given a navigation block (used by the template for the page header), fill

